test_that("characterize make incremental segments", {

  hy_net <- sf::read_sf(system.file("extdata/new_hope.gpkg",
                                    package = "hyfabric"))

  # mapview::mapview(hy_net)

  POI <- c("8894344", "8895326", "8893310", "8894154", "8894192", "8897784")

  inc_seg <- make_incremental_segments(hy_net, hy_net[hy_net$COMID %in% POI,], cores = NULL)

  # just characterization testing

  expect_equal(nrow(inc_seg), 112)

  expect_equal(names(inc_seg), c("LevelPathI", "Hydroseq", "COMID", "POI_ID"))

  expect_equal(nrow(inc_seg[inc_seg$POI_ID == "8893310",]), 2)

  # code below is to investigate what this does relative to aggregate_network
  # inc_seg <- right_join(select(hy_net, COMID), inc_seg)
  #
  # mapview::mapview(inc_seg)
  #
  # nearly the same?
  # outlets <- data.frame(ID = c(POI), type = rep("outlet", length(POI)))
  # outlets <- bind_rows(outlets, data.frame(ID = "8897784", type = "terminal"))
  #
  # hy_net <- hydroloom::add_toids(hy_net)
  #
  # segments <- hyRefactor::aggregate_network(select(hy_net, ID = COMID, toID = toid, Hydroseq, LevelPathID = LevelPathI),  outlets)
  #
  # mapview::mapview(segments$fline_sets)

})


