test_that("needs layer", {
  tmpf <- tempfile(fileext = ".gpkg")

  expect_true(needs_layer(tmpf, "check"))

  d <- sf::st_sf(p = 1, g = sf::st_sfc(sf::st_point(c(1,2)), crs = 4326))

  sf::write_sf(d, tmpf, "check")

  expect_false(needs_layer(tmpf, "check"))

  expect_true(needs_layer(tmpf, "check_two"))
})

test_that("rpu dep", {
  Sys.unsetenv("RPU_CODE")

  expect_equal(get_rpu_dependent_vars(),
               list(r = "01a", v = "01"))

  expect_equal(get_rpu_dependent_vars("02a"),
               list(r = "02a", v = "02"))

  expect_equal(get_rpu_dependent_vars("10a"),
               list(r = "10a", v = "10L"))

  expect_equal(get_rpu_dependent_vars("10e"),
               list(r = "10e", v = "10U"))

  expect_equal(get_rpu_dependent_vars("03g"),
               list(r = "03g", v = "08"))

  Sys.setenv(RPU_CODE = "03a")

  expect_equal(get_rpu_dependent_vars(),
               list(r = "03a", v = "03N"))

  Sys.setenv(RPU_CODE = "03c")

  expect_equal(get_rpu_dependent_vars(),
               list(r = "03c", v = "03S"))

  Sys.setenv(RPU_CODE = "03f")

  expect_equal(get_rpu_dependent_vars(),
               list(r = "03f", v = "03W"))

  Sys.setenv(HYDREG = "abc")

  expect_equal(get_rpu_dependent_vars(),
               list(r = "03f", v = "abc"))

  Sys.unsetenv(c("RPU_CODE","HYDREG"))
})
